# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .audiences_sub_object import AudiencesSubObject
from .campaign_create_query_resource_object_attributes_campaign_messages import (
    CampaignCreateQueryResourceObjectAttributesCampaignMessages,
)
from .campaign_create_query_resource_object_attributes_send_options import (
    CampaignCreateQueryResourceObjectAttributesSendOptions,
)
from .campaign_create_query_resource_object_attributes_tracking_options import (
    CampaignCreateQueryResourceObjectAttributesTrackingOptions,
)
from .send_strategy_sub_object import SendStrategySubObject


class CampaignCreateQueryResourceObjectAttributes(pydantic.BaseModel):
    name: str = pydantic.Field(description="The campaign name")
    audiences: AudiencesSubObject
    send_strategy: SendStrategySubObject
    send_options: typing.Optional[CampaignCreateQueryResourceObjectAttributesSendOptions] = pydantic.Field(
        description="Options to use when sending a campaign"
    )
    tracking_options: typing.Optional[CampaignCreateQueryResourceObjectAttributesTrackingOptions] = pydantic.Field(
        description="The tracking options associated with the campaign"
    )
    campaign_messages: CampaignCreateQueryResourceObjectAttributesCampaignMessages = pydantic.Field(
        alias="campaign-messages", description="The message(s) associated with the campaign"
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
