# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class MetricAggregateQueryResourceObjectAttributesByItem(str, enum.Enum):
    """
    Supported dimensions for grouping and filtering
    """

    ATTRIBUTED_CHANNEL = "$attributed_channel"
    ATTRIBUTED_FLOW = "$attributed_flow"
    ATTRIBUTED_MESSAGE = "$attributed_message"
    ATTRIBUTED_VARIATION = "$attributed_variation"
    CAMPAIGN_CHANNEL = "$campaign_channel"
    FLOW = "$flow"
    FLOW_CHANNEL = "$flow_channel"
    MESSAGE = "$message"
    MESSAGE_SEND_COHORT = "$message_send_cohort"
    VARIATION = "$variation"
    VARIATION_SEND_COHORT = "$variation_send_cohort"
    BOUNCE_TYPE = "Bounce Type"
    CAMPAIGN_NAME = "Campaign Name"
    CLIENT_CANONICAL = "Client Canonical"
    CLIENT_NAME = "Client Name"
    CLIENT_TYPE = "Client Type"
    EMAIL_DOMAIN = "Email Domain"
    FAILURE_SOURCE = "Failure Source"
    FAILURE_TYPE = "Failure Type"
    FROM_NUMBER = "From Number"
    FROM_PHONE_REGION = "From Phone Region"
    LIST = "List"
    MESSAGE_NAME = "Message Name"
    MESSAGE_TYPE = "Message Type"
    METHOD = "Method"
    SUBJECT = "Subject"
    TO_NUMBER = "To Number"
    TO_PHONE_REGION = "To Phone Region"
    URL = "URL"
    FORM_ID = "form_id"

    def visit(
        self,
        attributed_channel: typing.Callable[[], T_Result],
        attributed_flow: typing.Callable[[], T_Result],
        attributed_message: typing.Callable[[], T_Result],
        attributed_variation: typing.Callable[[], T_Result],
        campaign_channel: typing.Callable[[], T_Result],
        flow: typing.Callable[[], T_Result],
        flow_channel: typing.Callable[[], T_Result],
        message: typing.Callable[[], T_Result],
        message_send_cohort: typing.Callable[[], T_Result],
        variation: typing.Callable[[], T_Result],
        variation_send_cohort: typing.Callable[[], T_Result],
        bounce_type: typing.Callable[[], T_Result],
        campaign_name: typing.Callable[[], T_Result],
        client_canonical: typing.Callable[[], T_Result],
        client_name: typing.Callable[[], T_Result],
        client_type: typing.Callable[[], T_Result],
        email_domain: typing.Callable[[], T_Result],
        failure_source: typing.Callable[[], T_Result],
        failure_type: typing.Callable[[], T_Result],
        from_number: typing.Callable[[], T_Result],
        from_phone_region: typing.Callable[[], T_Result],
        list: typing.Callable[[], T_Result],
        message_name: typing.Callable[[], T_Result],
        message_type: typing.Callable[[], T_Result],
        method: typing.Callable[[], T_Result],
        subject: typing.Callable[[], T_Result],
        to_number: typing.Callable[[], T_Result],
        to_phone_region: typing.Callable[[], T_Result],
        url: typing.Callable[[], T_Result],
        form_id: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is MetricAggregateQueryResourceObjectAttributesByItem.ATTRIBUTED_CHANNEL:
            return attributed_channel()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.ATTRIBUTED_FLOW:
            return attributed_flow()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.ATTRIBUTED_MESSAGE:
            return attributed_message()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.ATTRIBUTED_VARIATION:
            return attributed_variation()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.CAMPAIGN_CHANNEL:
            return campaign_channel()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.FLOW:
            return flow()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.FLOW_CHANNEL:
            return flow_channel()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.MESSAGE:
            return message()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.MESSAGE_SEND_COHORT:
            return message_send_cohort()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.VARIATION:
            return variation()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.VARIATION_SEND_COHORT:
            return variation_send_cohort()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.BOUNCE_TYPE:
            return bounce_type()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.CAMPAIGN_NAME:
            return campaign_name()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.CLIENT_CANONICAL:
            return client_canonical()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.CLIENT_NAME:
            return client_name()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.CLIENT_TYPE:
            return client_type()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.EMAIL_DOMAIN:
            return email_domain()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.FAILURE_SOURCE:
            return failure_source()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.FAILURE_TYPE:
            return failure_type()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.FROM_NUMBER:
            return from_number()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.FROM_PHONE_REGION:
            return from_phone_region()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.LIST:
            return list()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.MESSAGE_NAME:
            return message_name()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.MESSAGE_TYPE:
            return message_type()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.METHOD:
            return method()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.SUBJECT:
            return subject()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.TO_NUMBER:
            return to_number()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.TO_PHONE_REGION:
            return to_phone_region()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.URL:
            return url()
        if self is MetricAggregateQueryResourceObjectAttributesByItem.FORM_ID:
            return form_id()
