# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime


class MetricResponseObjectResourceAttributes(pydantic.BaseModel):
    name: typing.Optional[str] = pydantic.Field(description="The name of the metric")
    created: typing.Optional[str] = pydantic.Field(
        description="Creation time in ISO 8601 format (YYYY-MM-DDTHH:MM:SS.mmmmmm)"
    )
    updated: typing.Optional[str] = pydantic.Field(
        description="Last updated time in ISO 8601 format (YYYY-MM-DDTHH:MM:SS.mmmmmm)"
    )
    integration: typing.Optional[typing.Dict[str, typing.Any]] = pydantic.Field(
        description="The integration associated with the event"
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
