# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .object_links import ObjectLinks
from .profile_enum import ProfileEnum
from .profile_response_object_resource_attributes import ProfileResponseObjectResourceAttributes


class ProfileResponseObjectResource(pydantic.BaseModel):
    type: ProfileEnum
    id: typing.Optional[str] = pydantic.Field(
        description="Primary key that uniquely identifies this profile. Generated by Klaviyo."
    )
    attributes: ProfileResponseObjectResourceAttributes
    links: ObjectLinks

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
