# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .device_metadata import DeviceMetadata
from .push_token_create_query_resource_object_attributes_background import (
    PushTokenCreateQueryResourceObjectAttributesBackground,
)
from .push_token_create_query_resource_object_attributes_enablement_status import (
    PushTokenCreateQueryResourceObjectAttributesEnablementStatus,
)
from .push_token_create_query_resource_object_attributes_platform import (
    PushTokenCreateQueryResourceObjectAttributesPlatform,
)
from .push_token_create_query_resource_object_attributes_profile import (
    PushTokenCreateQueryResourceObjectAttributesProfile,
)
from .push_token_create_query_resource_object_attributes_vendor import (
    PushTokenCreateQueryResourceObjectAttributesVendor,
)


class PushTokenCreateQueryResourceObjectAttributes(pydantic.BaseModel):
    token: str = pydantic.Field(description="A push token from APNS or FCM.")
    platform: PushTokenCreateQueryResourceObjectAttributesPlatform = pydantic.Field(
        description="The platform on which the push token was created."
    )
    enablement_status: typing.Optional[PushTokenCreateQueryResourceObjectAttributesEnablementStatus] = pydantic.Field(
        description="This is the enablement status for the individual push token."
    )
    vendor: PushTokenCreateQueryResourceObjectAttributesVendor = pydantic.Field(
        description="The vendor of the push token."
    )
    background: typing.Optional[PushTokenCreateQueryResourceObjectAttributesBackground] = pydantic.Field(
        description="The background state of the push token."
    )
    device_metadata: typing.Optional[DeviceMetadata]
    profile: PushTokenCreateQueryResourceObjectAttributesProfile = pydantic.Field(
        description="The profile associated with the push token to create/update"
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
