# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .error_source import ErrorSource


class ApiJobErrorPayload(pydantic.BaseModel):
    id: str = pydantic.Field(description="Unique identifier for the error.")
    code: str = pydantic.Field(description="A code for classifying the error type.")
    title: str = pydantic.Field(description="A high-level message about the error.")
    detail: str = pydantic.Field(description="Specific details about the error.")
    source: ErrorSource

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
